package com.edtoon.rott.ott;

import java.util.HashMap;

public abstract class OTTConstants
{
	public static final int DEFAULT_DURATION = 4, DEFAULT_SCALE = 6, DEFAULT_BPM = 63;

	public static final String PATTERN_HEADER_ID = "000";
	public static final String NOTE_INSTRUCTION_ID = "001";
	public static final String SCALE_INSTRUCTION_ID = "010";
	public static final String STYLE_INSTRUCTION_ID = "011";
	public static final String TEMPO_INSTRUCTION_ID = "100";
	public static final String VOLUME_INSTRUCTION_ID = "101";

	public static final String COMMAND_END = "00000000";

	public static final HashMap noteMap = new HashMap(), tempoMap = new HashMap(),
		scaleMap = new HashMap(), durationMap = new HashMap(), tempoDesc = new HashMap(),
		scaleDesc = new HashMap(), styleDesc = new HashMap(), volumeDesc = new HashMap(),
		noteDesc = new HashMap(), durationDesc = new HashMap(), specialDesc = new HashMap(),
		partDesc = new HashMap();

	static {
		noteMap.put("p", "0000");
		noteMap.put("c", "0001");
		noteMap.put("c#", "0010");
		noteMap.put("d", "0011");
		noteMap.put("d#", "0100");
		noteMap.put("e", "0101");
		noteMap.put("f", "0110");
		noteMap.put("f#", "0111");
		noteMap.put("g", "1000");
		noteMap.put("g#", "1001");
		noteMap.put("a", "1010");
		noteMap.put("a#", "1011");
		noteMap.put("b", "1011");
		noteMap.put("h", "1100");

		tempoMap.put("25", "00000");
		tempoMap.put("28", "00001");
		tempoMap.put("31", "00010");
		tempoMap.put("35", "00011");
		tempoMap.put("40", "00100");
		tempoMap.put("45", "00101");
		tempoMap.put("50", "00110");
		tempoMap.put("56", "00111");
		tempoMap.put("63", "01000");
		tempoMap.put("70", "01001");
		tempoMap.put("80", "01010");
		tempoMap.put("90", "01011");
		tempoMap.put("100", "01100");
		tempoMap.put("112", "01101");
		tempoMap.put("125", "01110");
		tempoMap.put("140", "01111");
		tempoMap.put("160", "10000");
		tempoMap.put("180", "10001");
		tempoMap.put("200", "10010");
		tempoMap.put("225", "10011");
		tempoMap.put("250", "10100");
		tempoMap.put("285", "10101");
		tempoMap.put("320", "10110");
		tempoMap.put("355", "10111");
		tempoMap.put("400", "11000");
		tempoMap.put("450", "11001");
		tempoMap.put("500", "11010");
		tempoMap.put("565", "11011");
		tempoMap.put("635", "11100");
		tempoMap.put("715", "11101");
		tempoMap.put("800", "11110");
		tempoMap.put("900", "11111");

		scaleMap.put("4", "00");
		scaleMap.put("5", "01");
		scaleMap.put("6", "10");
		scaleMap.put("7", "11");

		durationMap.put("1", "000");
		durationMap.put("2", "001");
		durationMap.put("4", "010");
		durationMap.put("8", "011");
		durationMap.put("16", "100");
		durationMap.put("32", "101");

		styleDesc.put("00", "Natural style");
		styleDesc.put("01", "Continuous style");
		styleDesc.put("10", "Staccato style");
		styleDesc.put("11", "RESERVED");

		scaleDesc.put("00", "Scale-1 (A=440Hz)");
		scaleDesc.put("01", "Scale-2 (A=880Hz)");
		scaleDesc.put("10", "Scale-3 (A=1.76kHz)");
		scaleDesc.put("11", "Scale-4 (A=3.52kHz)");

		tempoDesc.put("00000", "25");
		tempoDesc.put("00001", "28");
		tempoDesc.put("00010", "31");
		tempoDesc.put("00011", "35");
		tempoDesc.put("00100", "40");
		tempoDesc.put("00101", "45");
		tempoDesc.put("00110", "50");
		tempoDesc.put("00111", "56");
		tempoDesc.put("01000", "63");
		tempoDesc.put("01001", "70");
		tempoDesc.put("01010", "80");
		tempoDesc.put("01011", "90");
		tempoDesc.put("01100", "100");
		tempoDesc.put("01101", "112");
		tempoDesc.put("01110", "125");
		tempoDesc.put("01111", "140");
		tempoDesc.put("10000", "160");
		tempoDesc.put("10001", "180");
		tempoDesc.put("10010", "200");
		tempoDesc.put("10011", "225");
		tempoDesc.put("10100", "250");
		tempoDesc.put("10101", "285");
		tempoDesc.put("10110", "320");
		tempoDesc.put("10111", "355");
		tempoDesc.put("11000", "400");
		tempoDesc.put("11001", "450");
		tempoDesc.put("11010", "500");
		tempoDesc.put("11011", "565");
		tempoDesc.put("11100", "635");
		tempoDesc.put("11101", "715");
		tempoDesc.put("11110", "800");
		tempoDesc.put("11111", "900");

		volumeDesc.put("0000", "tone-off");
		volumeDesc.put("0001", "level-1");
		volumeDesc.put("0010", "level-2");
		volumeDesc.put("0011", "level-3");
		volumeDesc.put("0100", "level-4");
		volumeDesc.put("0101", "level-5");
		volumeDesc.put("0110", "level-6");
		volumeDesc.put("0111", "level-7");
		volumeDesc.put("1000", "level-8");
		volumeDesc.put("1001", "level-9");
		volumeDesc.put("1010", "level-10");
		volumeDesc.put("1011", "level-11");
		volumeDesc.put("1100", "level-12");
		volumeDesc.put("1101", "level-13");
		volumeDesc.put("1110", "level-14");
		volumeDesc.put("1111", "level-15");

		noteDesc.put("0000", "p");
		noteDesc.put("0001", "c");
		noteDesc.put("0010", "c#");
		noteDesc.put("0011", "d");
		noteDesc.put("0100", "d#");
		noteDesc.put("0101", "e");
		noteDesc.put("0110", "f");
		noteDesc.put("0111", "f#");
		noteDesc.put("1000", "g");
		noteDesc.put("1001", "g#");
		noteDesc.put("1010", "a");
		noteDesc.put("1011", "a#");
		noteDesc.put("1011", "b");
		noteDesc.put("1100", "h");
		noteDesc.put("1101", "RESERVED");
		noteDesc.put("1110", "RESERVED");
		noteDesc.put("1111", "RESERVED");

		durationDesc.put("000", "Full note");
		durationDesc.put("001", "1/2 note");
		durationDesc.put("010", "1/4 note");
		durationDesc.put("011", "1/8 note");
		durationDesc.put("100", "1/16 note");
		durationDesc.put("101", "1/32 note");
		durationDesc.put("110", "RESERVED");
		durationDesc.put("111", "RESERVED");

		specialDesc.put("00", "None");
		specialDesc.put("01", "Dotted note");
		specialDesc.put("10", "Double dotted note");
		specialDesc.put("11", "2/3 length");

		partDesc.put("00", "A-part");
		partDesc.put("01", "B-part");
		partDesc.put("10", "C-part");
		partDesc.put("11", "D-part");
	}
}
